import { defineComponent as T, ref as q, computed as g, resolveComponent as E, openBlock as l, createElementBlock as i, normalizeClass as n, createElementVNode as a, withModifiers as b, renderSlot as S, createVNode as I, createCommentVNode as m, Fragment as L, renderList as M, toDisplayString as u, unref as x, createTextVNode as p, withDirectives as R, vModelText as D } from "vue";
const G = { class: "inline-flex" }, U = /* @__PURE__ */ a("span", { class: "sr-only" }, "Previous", -1), H = ["onClick"], J = /* @__PURE__ */ a("span", { class: "sr-only" }, "Next", -1), K = { class: "text-sm text-gray-700" }, O = { class: "font-medium" }, Q = { class: "font-medium" }, W = { class: "font-medium" }, X = { key: 0 }, Y = {
  for: "search",
  class: "pr-3 text-gray-500 text-xs font-semibold uppercase"
}, ee = /* @__PURE__ */ T({
  __name: "v-pagination",
  props: {
    currentPage: {
      type: Number,
      required: !0
    },
    totalItems: {
      type: Number,
      required: !0
    },
    perPage: {
      type: Number,
      required: !0
    },
    pageRange: {
      type: Number,
      default: 2
    },
    goButton: {
      type: Boolean,
      default: !1
    },
    textBeforeInput: {
      type: String,
      default: "Go to page"
    },
    textAfterInput: {
      type: String,
      default: "Go"
    },
    borderActiveColor: {
      type: String,
      default: "border-indigo-500"
    },
    borderTextActiveColor: {
      type: String,
      default: "text-indigo-500"
    },
    styled: {
      type: String,
      default: "simple"
    },
    size: {
      type: String,
      default: "md"
    },
    label: {
      type: Boolean,
      default: !0
    }
  },
  emits: {
    "page-changed": (o) => typeof o == "number"
  },
  setup(o, { emit: z }) {
    const e = o, B = z, f = q(1), s = Math.ceil(e.totalItems / e.perPage), N = g(
      () => (e.currentPage - 1) * e.perPage + 1
    ), $ = g(() => {
      let t = e.currentPage * e.perPage;
      return e.totalItems < t ? e.totalItems : t;
    });
    g(() => e.currentPage === 1), g(() => e.currentPage >= s);
    const c = (t) => {
      t > 0 && t <= s && B("page-changed", t);
    }, h = g(() => {
      var t = e.currentPage - e.pageRange;
      return t > 0 ? t : 1;
    }), k = g(() => {
      var t = e.currentPage + e.pageRange;
      return t < s ? t : s;
    }), P = () => h.value !== 1, w = () => k.value < s, j = g(() => Array.from(
      Array(k.value + 1 - h.value).keys()
    ).map((r) => h.value + r)), y = {
      xs: "px-2 h-5 ",
      sm: "px-2 h-6 ",
      md: "px-3 h-8 ",
      lg: "px-4 h-10 ",
      xl: "px-5 h-12 "
    }, v = (t) => t === e.currentPage ? [
      y[e.size],
      "flex items-center justify-center leading-tight ",
      "text-blue-600 bg-blue-50 dark:bg-gray-700 dark:text-white",
      "border border-gray-300 dark:border-gray-700 border-solid",
      "dark:hover:bg-gray-700 dark:hover:text-white hover:bg-blue-100 hover:text-blue-700 "
    ] : [
      y[e.size],
      "flex items-center justify-center leading-tight",
      "text-gray-500 bg-white dark:bg-gray-800 dark:text-gray-400",
      "border border-gray-300 dark:border-gray-700 border-solid",
      "hover:bg-gray-100 hover:text-gray-700 dark:hover:bg-gray-700 dark:hover:text-white"
    ], A = (t) => t === 1 ? [
      y[e.size],
      "flex items-center justify-center first:rounded-l-md last:rounded-r-dm ml-0 leading-tight",
      "border border-gray-300 hover:bg-gray-100 hover:text-gray-700 border-solid",
      "cursor-not-allowed",
      "bg-gray-100 text-gray-700",
      "dark:border-gray-700 dark:hover:bg-gray-700 dark:hover:text-white dark:bg-gray-700 dark:text-white"
    ] : [
      y[e.size],
      "flex items-center justify-center first:rounded-l-md last:rounded-r-md ml-0 leading-tight",
      "border border-gray-300 hover:bg-gray-100 hover:text-gray-700 border-solid",
      "bg-white text-gray-500",
      "dark:bg-gray-800 dark:border-gray-700 dark:text-gray-400 dark:hover:bg-gray-700 dark:hover:text-white"
    ], V = (t) => t >= s ? [
      y[e.size],
      "flex items-center justify-center first:rounded-l-md last:rounded-r-dm ml-0 leading-tight",
      "border border-gray-300 hover:bg-gray-100 hover:text-gray-700 border-solid",
      "cursor-not-allowed",
      "bg-gray-100 text-gray-700",
      "dark:border-gray-700 dark:hover:bg-gray-700 dark:hover:text-white dark:bg-gray-700 dark:text-white"
    ] : [
      y[e.size],
      "flex items-center justify-center first:rounded-l-md last:rounded-r-md ml-0 leading-tight",
      "border border-gray-300 hover:bg-gray-100 hover:text-gray-700 border-solid",
      "bg-white text-gray-500",
      "dark:bg-gray-800 dark:border-gray-700 dark:text-gray-400 dark:hover:bg-gray-700 dark:hover:text-white"
    ];
    return (t, r) => {
      const C = E("v-icon");
      return l(), i("div", {
        class: n({ "flex justify-between items-center": o.goButton })
      }, [
        a("div", {
          class: n({
            "flex justify-between items-center": e.styled === "simple"
          })
        }, [
          a("nav", {
            class: n(["mb-2", { "mb-3": e.styled === "centered" }]),
            "aria-label": "Pagination"
          }, [
            a("div", G, [
              a("button", {
                disabled: "false",
                class: n(A(o.currentPage)),
                onClick: r[0] || (r[0] = b((d) => c(o.currentPage - 1), ["prevent"]))
              }, [
                S(t.$slots, "prev", {}, () => [
                  U,
                  I(C, { name: "previous" })
                ])
              ], 2),
              P() ? (l(), i("button", {
                key: 0,
                class: n(v(1)),
                onClick: r[1] || (r[1] = b((d) => c(1), ["prevent"]))
              }, " 1 ", 2)) : m("", !0),
              P() ? (l(), i("button", {
                key: 1,
                class: n(v(1))
              }, "...", 2)) : m("", !0),
              (l(!0), i(L, null, M(j.value, (d, F) => (l(), i("button", {
                key: F,
                class: n(v(d)),
                onClick: b((Z) => c(d), ["prevent"])
              }, u(d), 11, H))), 128)),
              w() ? (l(), i("button", {
                key: 2,
                class: n(v(x(s)))
              }, "...", 2)) : m("", !0),
              w() ? (l(), i("button", {
                key: 3,
                class: n(v(x(s))),
                onClick: r[2] || (r[2] = b((d) => c(x(s)), ["prevent"]))
              }, u(x(s)), 3)) : m("", !0),
              a("button", {
                disabled: "false",
                class: n(V(o.currentPage)),
                onClick: r[3] || (r[3] = b((d) => c(o.currentPage + 1), ["prevent"]))
              }, [
                S(t.$slots, "next", {}, () => [
                  J,
                  I(C, { name: "next" })
                ])
              ], 2)
            ])
          ], 2),
          e.label ? (l(), i("div", {
            key: 0,
            class: n({ "order-first": e.styled === "simple" })
          }, [
            a("p", K, [
              p(" Showing "),
              a("span", O, u(N.value), 1),
              p(" to "),
              a("span", Q, u($.value), 1),
              p(" of "),
              a("span", W, u(o.totalItems), 1),
              p(" results ")
            ])
          ], 2)) : m("", !0)
        ], 2),
        o.goButton ? (l(), i("div", X, [
          a("label", Y, u(o.textBeforeInput), 1),
          R(a("input", {
            type: "text",
            placeholder: "Page no",
            class: n(["w-28 px-4 py-1 rounded-l outline-none border-t-2 border-l-2 border-b-2 placeholder:text-xs uppercase font-semibold", `focus:${o.borderActiveColor}`]),
            "onUpdate:modelValue": r[4] || (r[4] = (d) => f.value = d)
          }, null, 2), [
            [D, f.value]
          ]),
          a("button", {
            class: "px-4 py-1.5 rounded-r bg-indigo-500 text-white",
            onClick: r[5] || (r[5] = b((d) => c(f.value), ["prevent"]))
          }, u(o.textAfterInput), 1)
        ])) : m("", !0)
      ], 2);
    };
  }
});
export {
  ee as default
};
